#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL.h>
#include "xboxJoy.h"
#include "../joystick.h"
#include <SDL_Image.h>
int xpos=0, ypos=0, xstretch=0, ystretch=0; 

void saveScreen()
{
	FILE *fp;

	fp=fopen("U:\\screensize.xsv","w+");

	fprintf(fp, "XPOS=%d\n", xpos);
	fprintf(fp, "YPOS=%d\n", ypos);
	fprintf(fp, "XSTRETCH=%d\n", xstretch);
	fprintf(fp, "YSTRETCH=%d\n", ystretch);

	fclose(fp);

	return;

}
void loadScreen()
{
	char str[500];
	FILE * fi;
	fi = fopen("U:\\screensize.xsv", "r");

	if(fi != NULL) 
	{
		do
		{
			fgets(str, sizeof(str), fi);
			if (!feof(fi))
			{

				if (strstr(str, "XPOS=") == str){

					xpos = atoi(str + 5);

				}
				else if (strstr(str, "YPOS=") == str){

					ypos = atoi(str + 5);

				}
				else if (strstr(str, "XSTRETCH=") == str){

					xstretch = atoi(str + 9);

				}
				else if (strstr(str, "YSTRETCH=") == str){

					ystretch = atoi(str + 9);
				}
			}
		}
		while (!feof(fi));
		fclose(fi);
	}

	//If user has changed screen size
	if((xstretch + ystretch + xpos + ypos) != 0)
	{
		//Set Screen Size 
		SDL_XBOX_SetScreenStretch(xstretch, ystretch);
		SDL_XBOX_SetScreenPosition(xpos, ypos);

	}
	else
	{
		// Default favors HDTV
		xpos=30;
		ypos=15;
		xstretch=-55;
		ystretch=-30;
		SDL_XBOX_SetScreenStretch(xstretch, ystretch);
		SDL_XBOX_SetScreenPosition(xpos, ypos);
		saveScreen();
	}
	return;
}

extern void JE_showVGA( void );
extern SDL_Surface* VGAScreen;
extern void JE_outText( SDL_Surface * screen, int x, int y, const char *s, unsigned int colorbank, int brightness );
void resize_screen()
{
	int axisL, axisLY, axisR, axisRY;

	int done = 0, button;

	SDL_Surface * IMG_RESIZE;
	IMG_RESIZE = IMG_Load("D:\\data\\resize.png");

	SDL_Surface *const surface = SDL_GetVideoSurface();

	if(!IMG_RESIZE) {
		printf("IMG_Load: %s\n", IMG_GetError());
	}

	SDL_BlitSurface(IMG_RESIZE, NULL, surface, NULL);
	//SDL_UpdateRect(VGAScreen, 0, 0, 640, 480);
	//JE_outText(VGAScreen, 10, 60, "Prepare to play...", 15, 4);

	do{

		poll_joystick(0);

		axisL = (int)SDL_JoystickGetAxis(joystick[0].handle, JOY_AXIS_LX);
		axisLY = (int)SDL_JoystickGetAxis(joystick[0].handle, JOY_AXIS_LY);
		axisR = (int)SDL_JoystickGetAxis(joystick[0].handle, JOY_AXIS_RX);
		axisRY = (int)SDL_JoystickGetAxis(joystick[0].handle, JOY_AXIS_RY);               

		if (axisLY < -JOY_DEADZONE)
		{
			ystretch -= 4;
			xstretch -= 8;

		}
		else if (axisLY > JOY_DEADZONE)
		{
			ystretch += 4;
			xstretch += 8;
		}

		//Screen RePosition
		if (axisR < -JOY_DEADZONE)
		{
			xpos = xpos - 1;
		}

		else if (axisR > JOY_DEADZONE)
		{
			xpos = xpos + 1;
		}

		else if (axisRY < -JOY_DEADZONE)
		{
			ypos = ypos - 1;
		}
		else if (axisRY > JOY_DEADZONE)
		{
			ypos = ypos + 1;
		}

		button = SDL_JoystickGetButton(joystick[0].handle, JOY_BTTN_START);

		if (button)
		{
			done = 1;
		}
		
		SDL_XBOX_SetScreenPosition(xpos, ypos);
		SDL_XBOX_SetScreenStretch(xstretch, ystretch);

		SDL_Flip(surface);
	}
	while (done == 0);

	saveScreen();

	SDL_FreeSurface(IMG_RESIZE);

	return;
}